org.eclipse.viatra.dse.base

## Class DesignSpaceManager

- java.lang.Object
- - org.eclipse.viatra.dse.base.DesignSpaceManager

-     public class DesignSpaceManager
      extends java.lang.Object

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DesignSpaceManager(ThreadContext context)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `backtrackUntilLastCommonActivation(java.lang.Object[] newTrajectory)`
    `void` | `backtrackXTimes(int steps)`
    `SolutionTrajectory` | `createSolutionTrajectroy()`
    `void` | `deregisterExploreEventHandler(IExploreEventHandler handler)`
    `boolean` | `executeRandomActivationId()`
    `int` | `executeTrajectory(java.lang.Object[] trajectoryToExecute)`
    `int` | `executeTrajectory(java.lang.Object[] trajectoryToExecute, int fromIncludedIndex, int toExcludedIndex)`
    `int` | `executeTrajectoryByTrying(java.lang.Object[] trajectoryToExecute)`
    `int` | `executeTrajectoryByTrying(java.lang.Object[] trajectoryToExecute, int fromIncludedIndex, int toExcludedIndex)`
    `int` | `executeTrajectoryByTryingWithoutStateCoding(java.lang.Object[] trajectoryToExecute)`
    `int` | `executeTrajectoryByTryingWithoutStateCoding(java.lang.Object[] trajectoryToExecute, int fromIncludedIndex, int toExcludedIndex)`
    `void` | `executeTrajectoryWithMinimalBacktrack(java.lang.Object[] trajectory)`
    `void` | `executeTrajectoryWithMinimalBacktrack(java.lang.Object[] trajectory, int toExcludedIndex)`
    `void` | `executeTrajectoryWithMinimalBacktrackWithoutStateCoding(java.lang.Object[] trajectory)`
    `void` | `executeTrajectoryWithMinimalBacktrackWithoutStateCoding(java.lang.Object[] trajectory, int toExcludedIndex)`
    `int` | `executeTrajectoryWithoutStateCoding(java.lang.Object[] trajectoryToExecute)`
    `int` | `executeTrajectoryWithoutStateCoding(java.lang.Object[] trajectoryToExecute, int fromIncludedIndex, int toExcludedIndex)`
    `void` | `fireActivation(java.lang.Object transition)`
    `Activation<?>` | `getActivationById(java.lang.Object activationId)`
    `java.lang.Object` | `getCurrentState()`
    `IDesignSpace` | `getDesignSpace()`
    `BatchTransformationRule<?,?>` | `getRuleByActivation(Activation<?> activation)`
    `BatchTransformationRule<?,?>` | `getRuleByActivationId(java.lang.Object activationId)`
    `IStateCoder` | `getStateCoder()`
    `java.util.List<java.lang.Object>` | `getTrajectoryFromRoot()`
    `TrajectoryInfo` | `getTrajectoryInfo()`
    `java.lang.Object` | `getTransitionByActivation(Activation<?> activation)`
    `java.util.Collection<java.lang.Object>` | `getTransitionsFromCurrentState()`
    `java.util.Collection<java.lang.Object>` | `getUntraversedTransitionsFromCurrentState()`
    `boolean` | `isCurentStateInTrajectory()`
    `boolean` | `isNewModelStateAlreadyTraversed()` Returns true if the given state is not owned by this crawler.
    `void` | `registerActivationCostProcessor(java.lang.String name, BatchTransformationRule<?,?> rule, ActivationFitnessProcessor activationFitnessProcessor)`
    `void` | `registerExploreEventHandler(IExploreEventHandler handler)`
    `void` | `setDesignSpace(IDesignSpace designSpace)`
    `boolean` | `tryFireActivation(java.lang.Object transition)`
    `boolean` | `undoLastTransformation()`
    `void` | `undoUntilRoot()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DesignSpaceManager

          public DesignSpaceManager(ThreadContext context)

  - ### Method Detail

    - #### fireActivation

          public void fireActivation(java.lang.Object transition)

    - #### tryFireActivation

          public boolean tryFireActivation(java.lang.Object transition)

    - #### executeRandomActivationId

          public boolean executeRandomActivationId()

    - #### executeTrajectory

          public int executeTrajectory(java.lang.Object[] trajectoryToExecute)

    - #### executeTrajectory

          public int executeTrajectory(java.lang.Object[] trajectoryToExecute,
                                       int fromIncludedIndex,
                                       int toExcludedIndex)

    - #### executeTrajectoryByTrying

          public int executeTrajectoryByTrying(java.lang.Object[] trajectoryToExecute)

    - #### executeTrajectoryByTrying

          public int executeTrajectoryByTrying(java.lang.Object[] trajectoryToExecute,
                                               int fromIncludedIndex,
                                               int toExcludedIndex)

    - #### executeTrajectoryWithoutStateCoding

          public int executeTrajectoryWithoutStateCoding(java.lang.Object[] trajectoryToExecute)

    - #### executeTrajectoryWithoutStateCoding

          public int executeTrajectoryWithoutStateCoding(java.lang.Object[] trajectoryToExecute,
                                                         int fromIncludedIndex,
                                                         int toExcludedIndex)

    - #### executeTrajectoryByTryingWithoutStateCoding

          public int executeTrajectoryByTryingWithoutStateCoding(java.lang.Object[] trajectoryToExecute)

    - #### executeTrajectoryByTryingWithoutStateCoding

          public int executeTrajectoryByTryingWithoutStateCoding(java.lang.Object[] trajectoryToExecute,
                                                                 int fromIncludedIndex,
                                                                 int toExcludedIndex)

    - #### getTransitionByActivation

          public java.lang.Object getTransitionByActivation(Activation<?> activation)

    - #### getActivationById

          public Activation<?> getActivationById(java.lang.Object activationId)

    - #### getRuleByActivation

          public BatchTransformationRule<?,?> getRuleByActivation(Activation<?> activation)

    - #### getRuleByActivationId

          public BatchTransformationRule<?,?> getRuleByActivationId(java.lang.Object activationId)

    - #### isNewModelStateAlreadyTraversed

          public boolean isNewModelStateAlreadyTraversed()

      Returns true if the given state is not owned by this crawler.

    - #### getTrajectoryFromRoot

          public java.util.List<java.lang.Object> getTrajectoryFromRoot()

    - #### getTransitionsFromCurrentState

          public java.util.Collection<java.lang.Object> getTransitionsFromCurrentState()

    - #### getUntraversedTransitionsFromCurrentState

          public java.util.Collection<java.lang.Object> getUntraversedTransitionsFromCurrentState()

    - #### undoLastTransformation

          public boolean undoLastTransformation()

    - #### backtrackXTimes

          public void backtrackXTimes(int steps)

    - #### backtrackUntilLastCommonActivation

          public int backtrackUntilLastCommonActivation(java.lang.Object[] newTrajectory)

    - #### executeTrajectoryWithMinimalBacktrack

          public void executeTrajectoryWithMinimalBacktrack(java.lang.Object[] trajectory)

    - #### executeTrajectoryWithMinimalBacktrack

          public void executeTrajectoryWithMinimalBacktrack(java.lang.Object[] trajectory,
                                                            int toExcludedIndex)

    - #### executeTrajectoryWithMinimalBacktrackWithoutStateCoding

          public void executeTrajectoryWithMinimalBacktrackWithoutStateCoding(java.lang.Object[] trajectory)

    - #### executeTrajectoryWithMinimalBacktrackWithoutStateCoding

          public void executeTrajectoryWithMinimalBacktrackWithoutStateCoding(java.lang.Object[] trajectory,
                                                                              int toExcludedIndex)

    - #### undoUntilRoot

          public void undoUntilRoot()

    - #### getCurrentState

          public java.lang.Object getCurrentState()

    - #### createSolutionTrajectroy

          public SolutionTrajectory createSolutionTrajectroy()

    - #### getTrajectoryInfo

          public TrajectoryInfo getTrajectoryInfo()

    - #### setDesignSpace

          public void setDesignSpace(IDesignSpace designSpace)

    - #### getDesignSpace

          public IDesignSpace getDesignSpace()

    - #### registerExploreEventHandler

          public void registerExploreEventHandler(IExploreEventHandler handler)

    - #### deregisterExploreEventHandler

          public void deregisterExploreEventHandler(IExploreEventHandler handler)

    - #### registerActivationCostProcessor

          public void registerActivationCostProcessor(java.lang.String name,
                                                      BatchTransformationRule<?,?> rule,
                                                      ActivationFitnessProcessor activationFitnessProcessor)

    - #### isCurentStateInTrajectory

          public boolean isCurentStateInTrajectory()

    - #### getStateCoder

          public IStateCoder getStateCoder()